<template>
  <div class="profile-view">
    <div class="user-info" v-if="getUser">
      <transition name="fade">
        <div v-if="getUser.photoURL" class="avatar-container">
          <img
            :src="userPhotoURL"
            alt="Аватар користувача"
            class="user-avatar"
          />
          
        </div>
      </transition>
      <div class="user-details">
        <div class="user-name">{{ userName }}</div>
        <div class="user-email">{{ userEmail }}</div>
        <div class="user-joined">Приєднався: {{ userJoinedDate }}</div>
        <div class="user-bio">{{ userBio }}</div>
      </div>
    </div>
    <div v-else>
      <p>Будь ласка, увійдіть, щоб переглянути свій профіль.</p>
    </div>
    
  </div>
</template>

<script>
import { mapGetters } from 'vuex';

export default {
  name: 'ProfileView',

  computed: {
    ...mapGetters('auth', ['getUser']),
    userPhotoURL() {
      return this.getUser ? this.getUser.photoURL : '';
    },
    userEmail() {
      return this.getUser ? this.getUser.email : '';
    },
    userName() {
      return this.getUser ? this.getUser.displayName : '';
    },
    userJoinedDate() {
      if (this.getUser && this.getUser.metadata && this.getUser.metadata.creationTime) {
        const joinedDate = new Date(this.getUser.metadata.creationTime);
        return this.formatDate(joinedDate);
      }
      return 'Н/Д';
    },
    userBio() {
      return 'Це мій профільний біо.';
    },
  },
  created() {
    if (!this.getUser) {
      this.$store
        .dispatch('auth/loadUser')
        .then(() => {})
        .catch((error) => {
          console.error('Не вдалося завантажити користувача:', error);
        });
    }
  },
  methods: {
    formatDate(date) {
      const options = { year: 'numeric', month: 'long', day: 'numeric' };
      return date.toLocaleDateString('uk-UA', options);
    },
  },
};
</script>

<style lang="scss" scoped>
.profile-view {
  display: flex;
  flex-direction: column;
  align-items: center;
  padding: 20px;
}

.fade-enter-active,
.fade-leave-active {
  transition: opacity 0.5s;
}

.fade-enter, .fade-leave-to /* .fade-leave-active в <2.1.8 */ {
  opacity: 0;
}

.fade-enter-to {
  opacity: 1;
}

.user-info {
  display: flex;
  align-items: center;
}

.avatar-container {
  position: relative;
}

.user-avatar {
  width: 100px;
  height: 100px;
  border-radius: 50%;
  margin-right: 20px;
  box-shadow: 0 0 10px rgba(0, 0, 0, 0.1);
}

.bubble-animation {
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  border-radius: 50%;
  background: radial-gradient(circle, #4caf50, #ffffff);
  animation: bubble 3s infinite alternate;
}

@keyframes bubble {
  0% {
    transform: scale(1);
  }
  100% {
    transform: scale(1.2);
  }
}

.user-details {
  display: flex;
  flex-direction: column;
}

.user-name {
  font-size: 1.5rem;
  font-weight: bold;
  margin-bottom: 8px;
}

.user-email {
  font-size: 1.2rem;
  color: #d6cece;
  margin-bottom: 10px;
}

.user-joined,
.user-bio {
  font-size: 1rem;
  color: #d4c9c9;
  margin-bottom: 10px;
}
</style>
